# hag_scri.py 
# obj: cree une Hagelin de type C (M209, C446, ...)

import sys
from hagelin_C import *
import string

#============================================
def restore( nomFichier ):
	if nomFichier == "":
		nomFichier = "config"
	f = open( nomFichier + ".key", "r" )
	ch = f.readline()
	ch = ch.strip()
	nbroues = int(ch)
	for i in range(nbroues):
		ch = f.readline()
		ch = ch.rstrip()
		lg = len(ch)
		for j in range(lg):
			if ch[j] != '_':
				c.setPinsON(i, ch[j] )
	ch = f.readline()
	ch = ch.strip()
	nbbarrettes = int (ch )
	for i in range( nbbarrettes ):
		ch = f.readline()
		ch = ch.rstrip()
		curseurGauche = int( ch[0] ) - 1
		curseurDroit  = int( ch[2] ) - 1
		if ( curseurGauche != -1 ): c.setALeftLug( i, curseurGauche) 
		if ( curseurDroit  != -1 ): c.setARightLug(i, curseurDroit )
	ch = f.readline()
	ch = ch.strip()
	c.setLetterShift(ch)
	f.close()
# ===================================
def is_maj(car):
	if string.find(string.ascii_uppercase,car) == -1: 
		return 0
	else:
		return 1
#============================================
if len(sys.argv) < 3:
        print "syntax : hag_scri.py InternKey_file ExternKey [debug]"
        print "Example: echo AAAAA | hag_scri.py MB AAAAAA"
	print "       the InternKey_file need to end by .key"
        sys.exit(1)
KEYINTERN= sys.argv[1]
KEYEXTERN= sys.argv[2]
if len(sys.argv) > 3: 
	debug = 1
else:
	debug = 0

c = Hagelin("Z",debug)
cryptogramme = ""
restore(KEYINTERN)
c.setExternalKey(KEYEXTERN)

#--------------------------------------
leTexte = sys.stdin.readlines()
crypto = ""	
for i in range(len(leTexte)):
	ch = leTexte[i]
	ch = ch.upper()
	for j in range(len(ch)):
		if not is_maj(ch[j]):
			continue
		car = c.cipher(ch[j])
		crypto = crypto + car

print crypto